/* ----
 * ---- file   : dsp.h
 * ---- author : Bastian Spiegel <bs@tkscript.de>
 * ---- legal  : (c) 2013 by Bastian Spiegel. 
 * ----          Distributed under terms of the LESSER GNU GENERAL PUBLIC LICENSE (LGPL). See 
 * ----          http://www.gnu.org/licenses/licenses.html#LGPL or COPYING_LGPL for further information.
 * ----
 * ---- info   : DSP main API. This is part of the "c64_tools" package.
 * ----
 * ---- changed: 06Sep2013, 08Sep2013
 * ----
 * ----
 */

#ifndef __C64_TOOLS_DSP_H__
#define __C64_TOOLS_DSP_H__

#include "cplusplus_begin.h"


// If defined, actually write to the DSP registers
#define DSP_WRITE_REGS defined


/*
 * (todo) document me
 *
 */
const char * S_CALL dsp_strerror(dsp_error_t _err);


/*
 * (todo) document me
 *
 */
S_EXTERN dsp_error_t S_CALL dsp_init (void);


/*
 * (todo) document me
 *
 */
S_EXTERN void S_CALL dsp_exit (void);


/*
 * (todo) document me
 *
 */
S_EXTERN dsp_error_t S_CALL dsp_mmap (sUI _physAddr, sUI _numBytes, sUI *_retAddr);


/*
 * (todo) document me
 *
 */
S_EXTERN dsp_error_t S_CALL dsp_munmap (sUI _virtAddr, sUI _numBytes);


/*
 * (todo) document me
 *
 */
S_EXTERN dsp_error_t S_CALL dsp_reg_write_32 (sUI _physAddr, sUI _value);


/*
 * (todo) document me
 *
 */
S_EXTERN dsp_error_t S_CALL dsp_reg_read_32 (sUI _physAddr, sUI *_retValue);


/*
 * (todo) document me
 *
 */
S_EXTERN dsp_error_t S_CALL dsp_reg_bit_set (sUI _physAddr, sUI _bitNr);


/*
 * (todo) document me
 *
 */
S_EXTERN dsp_error_t S_CALL dsp_reg_bit_clear (sUI _physAddr, sUI _bitNr);


/*
 * (todo) document me
 *
 */
S_EXTERN dsp_error_t S_CALL dsp_reset (void);


/*
 * (todo) document me
 *
 */
S_EXTERN dsp_error_t S_CALL dsp_start (sU32 _bootAddr);


/*
 * (todo) document me
 *
 */
S_EXTERN dsp_error_t S_CALL dsp_power_down (void);


/*
 * (todo) document me
 *
 */
S_EXTERN dsp_error_t S_CALL dsp_copy_to (sUI _physAddr, void *_srcBuf, sUI _numBytes);


/*
 * (todo) document me
 *
 */
S_EXTERN dsp_error_t S_CALL dsp_memset (sUI _physAddr, sU8 _c, sUI _numBytes);


#include "cplusplus_end.h"

#endif /* C64_TOOLS_DSP_H__ */
